//
//  ChatViewController.m
//  RapidEngineDemo
//
//  Created by fred yu on 8/27/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ChatViewController.h"
#import "CellWithLabel.h"


@implementation ChatViewController


- (id)initWithTabBarItemTitle:(NSString *)title iconName:(NSString *)iconName tag:(NSInteger)tag{
	if (self = [super init] ) {
		self.title = title;
		self.tableView.scrollEnabled = YES;
		UIImage *icon = [UIImage imageNamed:iconName];
		UITabBarItem *item = [[UITabBarItem alloc] initWithTitle:title image:icon tag:tag];
		self.tabBarItem = item;
		[item release];
		
		appData = [[UIApplication sharedApplication] delegate];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onFefreshOnLineUserList:) name:@"FefreshOnLineUserList" object:appData];
		
	}
	return self;
}


- (void)viewDidLoad {
    [super viewDidLoad];
}


#pragma mark -
#pragma mark Table view data source

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [appData.onLineUserArray count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"UserIDCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
		cell = [[[CellWithLabel alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		((CellWithLabel *)cell).lbl.text = [appData.onLineUserArray objectAtIndex:indexPath.row] ;
		
		((CellWithLabel *)cell).lbl.backgroundColor = [UIColor clearColor];
		((CellWithLabel *)cell).lbl.textColor = [UIColor colorWithRed:102.0/255.0 green:102.0/255.0 blue:102.0/255.0 alpha:1.0];
		
		
    }
    
		
	// Configure the cell.
	
    return cell;
}


-(void)onFefreshOnLineUserList:(NSNotification *)notification{
	
	[self.tableView reloadData];
}



#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
	/*
	 <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
	 [self.navigationController pushViewController:detailViewController animated:YES];
	 [detailViewController release];
	 */
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}



@end
