//
//  RapidEngineDemoAppDelegate.m
//  RapidEngineDemo
//
//  Created by fred yu on 8/26/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RapidEngineDemoAppDelegate.h"
#import "RootViewController.h"
#import "CustomUINavigationController.h"
#import "ClientSocket.h"
#import "ChatViewController.h"

@implementation RapidEngineDemoAppDelegate

@synthesize tabController;


#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after application launch.
    
    // Add the navigation controller's view to the window and display.


	window = [[UIWindow alloc] initWithFrame:[[UIScreen  mainScreen] bounds]];
	
	ClientSocket * 	mysocket = [ClientSocket clientWithHost:@"192.168.0.14" port:4530 andDelegate:nil];
	
	if([mysocket connect] == SCCInitOK){
		
		self.isReceiveOnLineList = FALSE;
		self.onLineUserArray = [[[NSMutableArray alloc] init] autorelease];
		
		NSLog(@"RootViewController::viewDidLoad mysocket connect] == SCCInitOK");
		[mysocket setIsConnected:YES];
		//如果连接成功，我们才把NavigationController加到window容器中
		//这个等待联接的黑屏，以后会用无敌风火轮代替的
		
		tabController = [[CustomUINavigationController alloc] init];
	
		[tabController setViewControllers:
		 [NSArray arrayWithObjects:
		  [[[UINavigationController alloc] initWithRootViewController:[[[RootViewController alloc] initWithTabBarItemTitle:@"RapidDemo" iconName:@"Messages.png" tag:1] autorelease]] autorelease],
		  nil]];
		
		chatTabController = [[CustomUINavigationController alloc] init];
		[chatTabController setViewControllers:
		 [NSArray arrayWithObjects:
		  [[[UINavigationController alloc] initWithRootViewController:[[[ChatViewController alloc] initWithTabBarItemTitle:@"ChatView" iconName:@"Messages.png" tag:1] autorelease]] autorelease],
		  nil]];
	
		[window addSubview:[tabController view]];
		[window addSubview:[chatTabController view]];
		
		[window bringSubviewToFront:self.tabController.view];
	}

	 
	[window makeKeyAndVisible];

    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}

-(void)loginSuccess{
	[window bringSubviewToFront:chatTabController.view];
	
	timer = [NSTimer scheduledTimerWithTimeInterval: 5.0
												  target: self
												selector: @selector(handleTimer:)
												userInfo: nil
												 repeats: YES];
	
}

-(void)requestOnLineUserList{

	ClientSocket * 	mysocket = [ClientSocket client];
	
	messageData = [NSMutableData data];
	
	unsigned short startToken = 0xFFFF;
	
	[messageData appendBytes:&startToken length:sizeof(startToken)];
	
	
	//获取在线用户列表
	unsigned short messageType = 112; 
	
	[self addUnsignedShort:messageType];
	
	int messageID = 1;
	
	[self addInt:messageID];
	
	
	unsigned char tempChar = 0;
	
	int messageBodyLen = 0; 
	
	[self addInt:messageBodyLen];
	
	
	RapidEngineDemoAppDelegate* appData = [[UIApplication sharedApplication] delegate];
	
	
	unsigned char userIDLen = ([appData.userID length]<=11)?[appData.userID length]:11;
	
	[self addUnsignedChar:userIDLen];
	
	
	
	if (userIDLen<11) {
		[messageData appendData:[appData.userID dataUsingEncoding:NSUTF8StringEncoding]];
		for (int i=0;i<11-userIDLen;i++) {
			[self addUnsignedChar:tempChar];
		}
	}
	else {
		[messageData appendData:[userID dataUsingEncoding:NSUTF8StringEncoding]];
	}
	
	
	NSString *destUserID = @"_0";
	unsigned char destUserIDLen = ([destUserID length]<=11)?[destUserID length]:11;
	
	[self addUnsignedChar:destUserIDLen];
	
	[messageData appendData:[destUserID dataUsingEncoding:NSUTF8StringEncoding]];
	for (int i=0;i<9;i++) {
		[self addUnsignedChar:tempChar];
	}
	
	[mysocket sendData:messageData];

}


-(void)refreshOnLineUserList{
	[[NSNotificationCenter defaultCenter] postNotificationName:@"FefreshOnLineUserList"
														object:self
													  userInfo:nil];
}


-(void)handleTimer:(NSTimer *)timer {
	//NSLog(@"RapidEngineDemoAppDelegate::handleTimer...");

	ClientSocket * 	mysocket = [ClientSocket client];
	
	messageData = [NSMutableData data];

	unsigned short startToken = 0xFFFF;
	
	[messageData appendBytes:&startToken length:sizeof(startToken)];
	
	
	//登录协议的messageType是116，些处我们用了硬编码，以后要改用常量 
	unsigned short messageType = 104; 
	
	[self addUnsignedShort:messageType];
	
	int messageID = 1;
	
	[self addInt:messageID];
	
	
	unsigned char tempChar = 0;
	
	int messageBodyLen = 0; 
	
	[self addInt:messageBodyLen];
	
	
	RapidEngineDemoAppDelegate* appData = [[UIApplication sharedApplication] delegate];
	
	
	unsigned char userIDLen = ([appData.userID length]<=11)?[appData.userID length]:11;
	
	[self addUnsignedChar:userIDLen];
	
	
	
	if (userIDLen<11) {
		[messageData appendData:[appData.userID dataUsingEncoding:NSUTF8StringEncoding]];
		for (int i=0;i<11-userIDLen;i++) {
			[self addUnsignedChar:tempChar];
		}
	}
	else {
		[messageData appendData:[userID dataUsingEncoding:NSUTF8StringEncoding]];
	}
	
	
	NSString *destUserID = @"_0";
	unsigned char destUserIDLen = ([destUserID length]<=11)?[destUserID length]:11;
	
	[self addUnsignedChar:destUserIDLen];
	
	[messageData appendData:[destUserID dataUsingEncoding:NSUTF8StringEncoding]];
	for (int i=0;i<9;i++) {
		[self addUnsignedChar:tempChar];
	}
	
	[mysocket sendData:messageData];
	
}


- (void)addUnsignedShort:(unsigned short)uShort{
	const int size = 2;
	union {
		unsigned short us;
		short ss;
		unsigned char buffer[size];
	} u;
	
	u.us = uShort;
	
	[messageData appendBytes:u.buffer length:size];
}

- (void)addInt:(int)iInt{
	const int size = 4;
	union {
		int sl;
		unsigned char buffer[size];
	} u;
	u.sl = iInt;
	
	[messageData appendBytes:u.buffer length:size];
}

- (void)addUnsignedChar:(unsigned char)uChar{
	unsigned char *buffer;
	buffer = &uChar;
	[messageData appendBytes:buffer length:1];
}


- (void)dealloc {

	[super dealloc];
}


@end

