//
//  RootViewController.m
//  RapidEngineDemo
//
//  Created by fred yu on 8/26/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RootViewController.h"
#import "CellWithTextField.h"
#import "ClientSocket.h"
#import "Login.h"
#import "RapidEngineDemoAppDelegate.h"

@implementation RootViewController


#pragma mark -
#pragma mark View lifecycle


- (id)initWithTabBarItemTitle:(NSString *)title iconName:(NSString *)iconName tag:(NSInteger)tag{
	if (self = [super initWithStyle:UITableViewStyleGrouped]) {
		self.title = title;
		self.tableView.scrollEnabled = NO;
		UIImage *icon = [UIImage imageNamed:iconName];
		UITabBarItem *item = [[UITabBarItem alloc] initWithTitle:title image:icon tag:tag];
		self.tabBarItem = item;
		[item release];
	}
	return self;
}


- (void)viewDidLoad {
	
    [super viewDidLoad];
	
    
	//[self.tableView reloadData];
	
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */


#pragma mark -
#pragma mark Table view data source

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 2;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	/*
	 if (cell == nil) {
	 cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue2 reuseIdentifier:CellIdentifier] autorelease];
	 }
	 */
    


	//AppDelegate* appData = [[UIApplication sharedApplication] delegate];
	if ([indexPath row] == 0) {
		CellIdentifier = @"UserNameCell";
		cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
		cell = [[[CellWithTextField alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		((CellWithTextField *)cell).lbl.text = @"昵称:";

		((CellWithTextField *)cell).lbl.backgroundColor = [UIColor clearColor];
		((CellWithTextField *)cell).lbl.textColor = [UIColor colorWithRed:102.0/255.0 green:102.0/255.0 blue:102.0/255.0 alpha:1.0];
			
		((CellWithTextField *)cell).txt.clearButtonMode = UITextFieldViewModeWhileEditing;
		((CellWithTextField *)cell).txt.keyboardType = UIKeyboardTypeEmailAddress;
		((CellWithTextField *)cell).txt.autocorrectionType = UITextAutocorrectionTypeNo;
		((CellWithTextField *)cell).txt.autocapitalizationType = UITextAutocapitalizationTypeNone;
		((CellWithTextField *)cell).txt.returnKeyType	= UIReturnKeyNext;
		((CellWithTextField *)cell).txt.tag = 1;
		((CellWithTextField *)cell).txt.delegate = self;
			
			
			
	}else if ([indexPath row] == 1) {
			
		CellIdentifier = @"PasswordCell";
		cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
			
		cell = [[[CellWithTextField alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
			
		((CellWithTextField *)cell).lbl.text = @"密码:";

		((CellWithTextField *)cell).lbl.backgroundColor = [UIColor clearColor];
		((CellWithTextField *)cell).lbl.textColor = [UIColor colorWithRed:102.0/255.0 green:102.0/255.0 blue:102.0/255.0 alpha:1.0];
		((CellWithTextField *)cell).txt.clearButtonMode = UITextFieldViewModeWhileEditing;
		((CellWithTextField *)cell).txt.secureTextEntry = YES;
		((CellWithTextField *)cell).txt.autocorrectionType = UITextAutocorrectionTypeNo;
		((CellWithTextField *)cell).txt.autocapitalizationType = UITextAutocapitalizationTypeNone;
		((CellWithTextField *)cell).txt.returnKeyType = UIReturnKeyDone;
		((CellWithTextField *)cell).txt.tag = 2;
		((CellWithTextField *)cell).txt.delegate = self;
			
	}
		
	
    return cell;
}

- (void)addUnsignedShort:(unsigned short)uShort{
	const int size = 2;
	union {
		unsigned short us;
		short ss;
		unsigned char buffer[size];
	} u;
	
	u.us = uShort;
	
	[messageData appendBytes:u.buffer length:size];
}

- (void)addInt:(int)iInt{
	const int size = 4;
	union {
		int sl;
		unsigned char buffer[size];
	} u;
	u.sl = iInt;
	
	[messageData appendBytes:u.buffer length:size];
}

- (void)addUnsignedChar:(unsigned char)uChar{
	unsigned char *buffer;
	buffer = &uChar;
	[messageData appendBytes:buffer length:1];
}



-(BOOL)textFieldShouldReturn:(UITextField*)field
{
	if (field.tag == 1) {
		//NSLog(@"昵称");
		[field resignFirstResponder];
		
		[(UITextField *)[self.view viewWithTag:2] becomeFirstResponder];
	} else{
		//NSLog(@"密码");

		ClientSocket * 	mysocket = [ClientSocket client];
		
		messageData = [NSMutableData data];
		
		Login *loginBody = [[Login alloc] init];
		loginBody.password = [(UITextField *)[self.view viewWithTag:2] text];
		loginBody.passwordLen = [loginBody.password length];
		
		
		unsigned short startToken = 0xFFFF;
		
		[messageData appendBytes:&startToken length:sizeof(startToken)];
		
		
		//登录协议的messageType是116，些处我们用了硬编码，以后要改用常量 
		unsigned short messageType = 116; 
		
		[self addUnsignedShort:messageType];
		
		
		int messageID = 1;
		
		[self addInt:messageID];
		
		
		unsigned char tempChar = 0;
		
		if ([loginBody.password isEqualToString:@""]) {
			loginBody.passwordLen = 8;
		}
		
		
		int messageBodyLen = 4 + loginBody.passwordLen; // int 占4字节

		[self addInt:messageBodyLen];
		
		NSString *userID = [(UITextField *)[self.view viewWithTag:1] text];
		
		unsigned char userIDLen = ([userID length]<=11)?[userID length]:11;
		
		[self addUnsignedChar:userIDLen];
		
		
		
		if (userIDLen<11) {
			[messageData appendData:[userID dataUsingEncoding:NSUTF8StringEncoding]];
			for (int i=0;i<11-userIDLen;i++) {
				[self addUnsignedChar:tempChar];
			}
		}
		else {
			[messageData appendData:[userID dataUsingEncoding:NSUTF8StringEncoding]];
		}
		
		
		NSString *destUserID = @"_0";
		unsigned char destUserIDLen = ([destUserID length]<=11)?[destUserID length]:11;
		
		[self addUnsignedChar:destUserIDLen];
		
		[messageData appendData:[destUserID dataUsingEncoding:NSUTF8StringEncoding]];
		for (int i=0;i<9;i++) {
			[self addUnsignedChar:tempChar];
		}
		
		
		[self addInt:loginBody.passwordLen];
		
		if ([loginBody.password isEqualToString:@""]) {
			for (int i=0; i<8; i++) {
				[self addUnsignedChar:tempChar];
			}
		}
		else {
			if (loginBody.passwordLen<8) {
				[messageData appendData:[loginBody.password dataUsingEncoding:NSUTF8StringEncoding]];
				
				for (int i=0; i<8-loginBody.passwordLen; i++) {
					[self addUnsignedChar:tempChar];
				}
				
			}
			else {
				[messageData appendData:[loginBody.password dataUsingEncoding:NSUTF8StringEncoding]];
			}
			
		}
		
		RapidEngineDemoAppDelegate* appData = [[UIApplication sharedApplication] delegate];
		
		appData.userID = userID;
		
		
		[mysocket sendData:messageData];
		[field resignFirstResponder];
	}
	return YES;
}



/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/




#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
	/*
	 <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
	 [self.navigationController pushViewController:detailViewController animated:YES];
	 [detailViewController release];
	 */
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end

